use opossum::error::OpossumError;
use opossum::nodes::Dummy;
use opossum::OpticScenery;

use std::fs::File;
use std::io::Write;

fn main() -> Result<(), OpossumError> {
    println!("opticscenery example");
    let mut scenery = OpticScenery::new();
    scenery.set_description("OpticScenery demo");
    println!("default opticscenery: {:?}", scenery);
    println!("export to `dot` format: {}", scenery.to_dot()?);
    let node1 = scenery.add_element("my optic", Dummy::default());
    let node2 = scenery.add_element("my other optic", Dummy::default());
    scenery.connect_nodes(node1, "rear", node2, "front")?;
    let path = "graph.dot";
    let mut output = File::create(path).unwrap();
    write!(output, "{}", scenery.to_dot()?).unwrap();

    Ok(())
}
