//! This is the documentation for the **OPOSSUM** software package. **OPOSSUM** stands for
//! **Op**en-source **O**ptics **S**imulation **S**oftware and **U**nified **M**odeller.
//!
mod light;
pub mod lightdata;
/// The basic structure representing an optical element
pub mod optic_node;
/// The basic structure containing the entire optical model
mod optic_scenery;

pub mod optic_ports;

pub mod nodes;

pub mod analyzer;

pub mod error;

pub mod spectrum;

pub use optic_scenery::OpticScenery;
